//section calibration accès par bouton enfoncé à la mise sous tension

void factory_settings() {
  if(old_version != User.raduino_version){
  lcd.setCursor(0, 0);
  lcd.print(F("loading default"));
  lcd.setCursor(0, 1);
  lcd.print(F("settings...  "));
  EEPROM.put(4, User); // save all user parameters to EEPROM
  active_delay(3000);
  }
  lcd.setCursor(0, 0);
  lcd.print(F("RF calibration  "));
  lcd.setCursor(0, 1);
  lcd.print(F("settings...  "));
  EEPROM.get(4, User);  //retrieve user settings from EEPROM
  active_delay(3000);
  while (btnDown())  active_delay(100);
  calibrateMaster();
  lcd.setCursor(0, 0);
  lcd.print(F("Voltmeter       "));
  lcd.setCursor(0, 1);
  lcd.print(F("calibration     "));
  active_delay(2000);
  Cal_Voltmeter();
  lcd.setCursor(0, 0);
  lcd.print(F("BFO frequency   "));
  lcd.setCursor(0, 1);
  lcd.print(F("calibration     "));
  active_delay(2000);
  BFOadj();
  lcd.setCursor(0, 0);
  lcd.print(F("1st IF center   "));
  lcd.setCursor(0, 1);
  lcd.print(F("calibration     "));
  active_delay(2000);
  Cal_1stIF();
  lcd.setCursor(0, 0);
  lcd.print(F("CW filter center"));
  lcd.setCursor(0, 1);
  lcd.print(F("calibration     "));
  active_delay(2000);
  Cal_CWfilter();
  lcd.setCursor(0, 0);
  lcd.print(F("Smeter S9/-73dBm"));
  lcd.setCursor(0, 1);
  lcd.print(F("calibration     "));
  active_delay(2000);
  Cal_Smeter();

}

/**  Calibration mode
 * Load the new correction and resets the clock 0 to 10 MHz on BFO */
/*
void recalibrate(long CalFactor){
    si5351bx_vcoa = (SI5351BX_XTAL * SI5351BX_MSA) + CalFactor; // apply the calibration correction factor
    //set BFO clock 0 at 10 MHz
    si5351bx_setfreq(OutBFO, 10000000L);
}
*/

void calibrateMaster(){
    int knob;
    long correction;
    lcd.setCursor(0, 0);
    lcd.print(F("Ref Calibration?"));
    lcd.setCursor(0, 1);
    lcd.print(F("Esc FCT /Val PTT"));
    while (digitalRead(PTT) == HIGH || !btnDown()){
      if (btnDown())
      return;
      if (digitalRead(PTT) == LOW)
      break;
    }
    lcd.setCursor(0, 0);
    lcd.print(F("Set  BFO = 10MHz"));
    //recalibrate(0);
    active_delay(2000);

    while(digitalRead(PTT) == HIGH && !btnDown()){
      knob = analogRead(ANALOG_TUNING);
      //correction = (512-knob) * 250UL ; // range +/- 131072 correspond to +/-146 ppm range with 0.3 ppm resolution, 1Hz resolution at 30MHz
      correction = (1337-knob) * 127UL ; // range +/- 65024 correspond to +/-73 ppm range with 0.15 ppm resolution, 0.5Hz resolution at 30MHz
      si5351bx_vcoa = (SI5351BX_XTAL * SI5351BX_MSA) + correction; // apply the calibration correction factor
      si5351bx_setfreq(OutBFO, 10000000L);  //set BFO clock 0 at 10 MHz
      
      if (btnDown()){   //abort if this button is down
        // Don't save the settings
        break;
      }
      sprintf(c, "%4d", knob);
      printLine1(c);
    }
    //save the setting
    if (digitalRead(PTT) == LOW){
      lcd.setCursor(0, 1);
      lcd.print(F("Calibration done"));
      EEPROM.put(0, correction); // save only calibration value to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PTT
      active_delay(2000);
    }
}


void Cal_Voltmeter(){ // reglage de +/-15 unutés autour de la valeur de base
    int knob;
    int CorrVmeter;
    unsigned int  Vmeter;
    lcd.setCursor(0, 1);
    sprintf(c, "     (%3d", User.VmeterCal); //affiche la dernière valeur mémorisée
    strcat(c, ")valPTT");
    lcd.print(c);
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      knob = analogRead(ANALOG_TUNING) >> 5;// reduce resolution to 1/4
      CorrVmeter = User.VmeterCal + (knob - 16);
      sprintf(c, "%3d", CorrVmeter);
      strcat(c, " cal coef.");
      printLine1(c);
      Vmeter = analogRead(ANALOG_VMETER) >> 2; // 1023/4=255.75 for 25.6 Vmax
      Vmeter = Vmeter * CorrVmeter; //apply correction factor
      Vmeter = Vmeter >>7 ;        // divide as fixed point integer
      sprintf(b, "%3d", Vmeter);   // convert to char string   
      sprintf(meter, "%.2s.%.1s", b, b+2); // formate the string
      strcat(meter, "V");         // add symbol Volt
      lcd.setCursor(0, 1);
      lcd.print(meter);
    }
    while (btnDown())  active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.VmeterCal = CorrVmeter;
      lcd.setCursor(0, 1);
      lcd.print(F("Volt cal stored "));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PPT
      active_delay(2000);
    }
}


void BFOadj(){
    int knob;
    long CorrBFO = 0;
    lcd.setCursor(0, 1);
    sprintf(c, "(%8ld", User.BFO); //affiche la dernière valeur mémorisée
    strcat(c, ")valPTT");
    lcd.print(c);
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      knob = analogRead(ANALOG_TUNING) >> 2; // reduce resolution to 1/4
      CorrBFO = User.BFO + (knob-128) * 10L;
      si5351bx_setfreq(OutBFO, CorrBFO);
      sprintf(c, " %8ld", CorrBFO);
      strcat(c, " Hz BFO");
      printLine1(c);
    }
    while (btnDown())  active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.BFO = CorrBFO;
      lcd.setCursor(0, 1);
      lcd.print(F("Correction stored"));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PPT
      active_delay(2000);
    }
}


void Cal_1stIF(){ // reglage de +/-256 kHz autour de la valeur de base
    int knob;
    long Corr1stIF;
    sprintf(c, "(%8ld", User.FIRST_IF); //affiche la dernière valeur mémorisée
    strcat(c, ")valPTT");
    printLine2(c);
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      knob = analogRead(ANALOG_TUNING) >> 1;// reduce resolution to 1/4
      Corr1stIF = User.FIRST_IF + (knob - 256)*1000L;
      sprintf(c, " %8ld", Corr1stIF);
      strcat(c, "Hz 1-IF");
      printLine1(c);
    }
    while (btnDown())  active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.FIRST_IF = Corr1stIF;
      lcd.setCursor(0, 1);
      lcd.print(F("1st IF stored   "));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PPT
      active_delay(2000);
    }
}


void Cal_CWfilter(){ // reglage de +/-256 kHz autour de la valeur de base
    int knob;
    long CorrCWfreq;
    sprintf(c, "(%8ld", User.CW_NARR_FILT); //affiche la dernière valeur mémorisée
    strcat(c, ")valPTT");
    printLine2(c);
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      knob = analogRead(ANALOG_TUNING) >> 1;// reduce resolution to 1/4
      CorrCWfreq = User.CW_NARR_FILT + (knob - 256)*10L;
      sprintf(c, " %8ld", CorrCWfreq);
      strcat(c, "Hz CWcf");
      printLine1(c);
      si5351bx_setfreq(OutBFO, CorrCWfreq);
    }
    while (btnDown())  active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.CW_NARR_FILT = CorrCWfreq;
      lcd.setCursor(0, 1);
      lcd.print(F("CW filter stored"));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PPT
      active_delay(2000);
    }
}


void Cal_Smeter(){ // reglage d'un coef de 1(255) à 0.8 (204)
    int knob;
    byte CorrSmeter;
    unsigned int  SmeterIn;
    sprintf(c, "     (%3d", User.SmeterCal); //affiche la dernière valeur mémorisée 2e ligne
    strcat(c, ")valPTT");
    printLine2(c);

    long VFOcal = 0;                     // Si5351 calibration and set 14.1 MHz SSB test freq
    EEPROM.get(0, VFOcal);
    si5351bx_vcoa = (SI5351BX_XTAL * SI5351BX_MSA) + VFOcal; // apply the calibration correction factor
    si5351bx_setfreq(OutLO2, User.FIRST_IF + User.BFO + User.IFshift ); //set 2nd LO
    si5351bx_setfreq(OutBFO, User.BFO + User.IFshift); //default mode is SSB
    long CalSmeterFreq = 14099000L;
    setFrequency(CalSmeterFreq);
    
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      knob = analogRead(ANALOG_TUNING) >> 3;// reduce resolution to 1/8
      CorrSmeter = byte(knob + 126);
      sprintf(c, "%3d", CorrSmeter);
      strcat(c, " 14.100 MHz  ");
      printLine1(c);
      SmeterIn = analogRead(ANALOG_SMETER) >> 3; // 1023/8=128max
      SmeterIn = SmeterIn * CorrSmeter; //apply correction factor
      SmeterIn = SmeterIn >>8 ;        // divide by 256 as fixed point integer
      sprintf(c, "%2d", SmeterIn);   // display corrected Smeter
      strcat(c, "=45");
      printLine2(c);
    }
    while (btnDown())  active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.SmeterCal = CorrSmeter;
      lcd.setCursor(0, 1);
      lcd.print(F("Smeter cal stored"));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      do {active_delay(100);} while (digitalRead(PTT) == LOW)  ; //attendre relâché PPT
      active_delay(2000);
    }
}
