


/* display routines */
void printLine1(char *c){
    lcd.setCursor(0, 0);
    lcd.print(c);
}

void printLine2(char *c){
    lcd.setCursor(0, 1);
    lcd.print(c);
}

//Smètre, voltmètre et SWRmètre
void updateMeter(){
   unsigned int  Vmeter;
   int Smeter;
   int Vforward;
   int Vreverse=0;
   int Vswr;
   int deltaVfVr;
   byte i;
   // echantillonnage et filtrage
   Smeter = analogRead(ANALOG_SMETER); // 0 to 2.34 V
   Vforward = Smeter;
   if (inTx){   //en émission Smètre indique le niveau HF forward ou reverse, ou SWR en mode tune
     Vreverse = analogRead(FBUTTON);  //lecture du coupleur pwr reverse
     if (Dispreverse || TUNE){
       Smeter=Vreverse;
     }
     if (Smeter >= SmeterPrev){
       SmeterPrev = Smeter;  //max hold
     }
     else {           //64*Y(n) = X(n) - Y(n-1) + 64*Y(n-1)
       Smeter = 63*SmeterPrev; //filtre numérique pour la décroissance du maxhold
       Smeter = Smeter >> 6;
       SmeterPrev = Smeter; 
     }
     if(TUNE){//clacul du SWR en mode tune
      //SWR = (Vf+Vr)/(Vf-Vr) avec Vf > Vr pour éviter division par 0 donc diviser par 1, et Vf+Vr=2Vf si SWR infini, soit < 1024
      if (Vforward > Vreverse){
        deltaVfVr = Vforward - Vreverse;
        Vswr = Vforward + Vreverse;
        Vswr = Vswr * 10;
        Vswr = Vswr / deltaVfVr;
      }
     }
     Smeter = Smeter >>3;
    }
    else{ //Rx Smeter correction at S9
       Smeter = Smeter >>3;
       Smeter = Smeter * User.SmeterCal;
       Smeter = Smeter >>8;
    }

    if(inTx && TUNE){ // indication SWR numérique en mode tune sinon voltmètre
      if(Vswr <100){
        sprintf(b, "%3d", Vswr);   // convert to char string   
        sprintf(meter, "%.2s.%.1s", b, b+2); // formate the string
        strcat(meter, "/1");         // add symbol Volt  
      }
      else{
        sprintf(meter, "inf.  "); 
      }
       
    }
    else{     //Voltmeter
     Vmeter = analogRead(ANALOG_VMETER) >> 2; // 1023/4=255.75 for 25.6 Vmax
     Vmeter = Vmeter * User.VmeterCal; //apply correction factor
     Vmeter = Vmeter >>7 ;        // divide as fixed point integer
     if (Vmeter < 46){
     sprintf(meter, "PAoff ");    
     }
     else{
       if (inTx){
         if (Vmeter <= VmeterPrev){
           VmeterPrev = Vmeter;  // minimum hold in Tx
         }
       }
       else{
         VmeterPrev = Vmeter ;
       }
       if (Vreverse > 256){
         TempoSWR = 50; // seuil dépassé SWR > 3
         CATisHighSWR = true;
       }
       if (TempoSWR != 0) { 
         TempoSWR--;
         sprintf(meter, "!SWR! "); // afficher à la place du voltmètre
       }
       else{
           CATisHighSWR = false;
           Vmeter = VmeterPrev ;
           sprintf(b, "%3d", Vmeter);   // convert to char string   
           sprintf(meter, "%.2s.%.1s", b, b+2); // formate the string
           strcat(meter, "V ");         // add symbol Volt 
      }
    }
   }
 

  
  SmeterCAT = byte (Smeter >>2);  // Smter for CAT , clamped
  if (SmeterCAT > 15){
    SmeterCAT = 15;
  }
  //Smeter bar graph  
  for (i = 6; i < 16; i++){ // prepare and display bargraph, buffer : meter
    if (Smeter >= 5)
          meter[i] = 6;
    else if (Smeter > 0)
      meter[i] = 1 + Smeter;
    else
      meter[i] = 1;
    Smeter = Smeter - 5;
  }
  meter[i] = 0; // null at end of 16 char string
  lcd.setCursor(0, 1);
  lcd.print(meter);
}


// affichage de la fréquence et du mode
void updateDisplay(){
  unsigned long dispfrequency;
  if (ritOn && !inTx){
    dispfrequency = frequency + RIToffset;
  }
  else {
    dispfrequency = frequency;
  }
  sprintf(b, "%8ld", dispfrequency);      
  sprintf(c, "%.2s.%.3s.%.2s%", b, b+2, b+5);
  if (TUNE == true){
    strcat(c, "tuneSWR");
  }
  else{
    
    if (vfoActive == VFO_A){
      if(inTx && SplitOn){
        strcat(c, "B");
      }
      else  strcat(c, "A");
    }
    else{
      if(inTx && SplitOn){
        strcat(c, "A");
      }
      else  strcat(c, "B");
    }

    if (fastUP) strcat(c, ">");
    else if (fastDOWN) strcat(c, "<");
    else if (PA_on) strcat(c, "p");
    else strcat(c, " ");
  /*  
    if (User.IFshift !=0)
      strcat(c, "^");
      else   strcat(c, " ");
*/
    if (!CwOn){
      if (isUSB == 1)
        strcat(c, "USB");
      else
        strcat(c, "LSB");  
    }
    else
      strcat(c, "CW ");
    if (inTx){
      strcat(c, "t");
        if (Dispreverse){strcat(c, "R");}
        else {strcat(c, "F"); }       
    }
    else if (ritOn){
      if (RIToffset > 0)
      strcat(c, "R+");
      else if (RIToffset == 0)
      strcat(c, "R0");
      else
      strcat(c, "R-");
     }
    else if (SplitOn)
      strcat(c, "sp");
      else
      strcat(c, "rx");
  }    
    printLine1(c);
}
