
void doMenu(){
  int MenuSelect;
  byte btnState;
  menuOn = 1;
   while(menuOn){
    checkCAT();
    MenuSelect = analogRead(ANALOG_TUNING);
    //downscale the selection
        MenuSelect = (MenuSelect-64) >> 6;
    btnState = btnDown();
     active_delay(100);
     switch(MenuSelect){
      case 0:
        PowerSWRToggle(btnState);
        break;
      case 1:
        splitToggle(btnState);
        break;
      case 2:
        if (CwOn) exitMenu(btnState);
        else setIFshift(btnState);
        break;
      case 3:
        CWSSBToggle(btnState);
        break;
      case 4:
        ritToggle(btnState);
        break;
      case 5:
        vfoToggle(btnState);
        break;
      case 6:
        exitMenu(btnState);
        break;
      case 7:
        Tune(btnState);
        break;  
      case 8:
        SetCWDotTime(btnState);
        break;
      case 9:
        SetCWtimeout(btnState);
        break;
      case 10:
        SetCWSideTone(btnState);
        break;
      case 11:
        KeyerMode(btnState);
        break;
      case 12:
        if(Iambic_Key){
          IambicMode(btnState);
        }
        else{
          exitMenu(btnState);
        }
        break;
        default:
        exitMenu(btnState);
        break;
     } 
  }
}


void exitMenu(byte btn){
   if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("Exit Menu?      "));
  }
  else{
      menuOn = 0;
      resetBasefrequency();
      setFrequency(frequency);    
      updateDisplay();
  }
}



void PowerSWRToggle(byte btn){
  if (!btn){
    ToggleDone = false;
    if (Dispreverse){
      lcd.setCursor(0, 1);
      lcd.print(F("SmeterTx Reverse"));
    }
    else{
      lcd.setCursor(0, 1);
      lcd.print(F("SmeterTx Forward"));
    }
  }
  else if (!ToggleDone){
      if (Dispreverse){
        Dispreverse = false;
      }
      else {
        Dispreverse = true;
      }
      ToggleDone = true;
  }
}



void splitToggle(byte btn){ //VFO Rx on active VFO, Tx on inactive VFO
  if (!btn){
    if (SplitOn == 1){
      lcd.setCursor(0, 1);
      lcd.print(F("Split:On        "));
    }
    else{
      lcd.setCursor(0, 1);
      lcd.print(F("Split:Off       "));
    }
  }
  else {
   menuOn = 0;
    if (SplitOn == 0){
        SplitOn = 1;
    }
    else  SplitOn = 0;
   resetBasefrequency();
   updateDisplay();
  }
}



void setIFshift(byte btn){
    int knob;
    unsigned long shift;

    if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("Set IF shift ?  "));
      return;
    }
    while(btnDown()){//attente tant que le bouton est pressé
      active_delay(50);
    }
      lcd.setCursor(0, 1);
      sprintf(c, "(%5d", User.IFshift); //affiche la dernière valeur mémorisée
      strcat(c, ") val. PTT");
      lcd.print(c);
    while(digitalRead(PTT) == HIGH){
      knob = analogRead(ANALOG_TUNING) >> 2; // reduce resolution to 1/4
      shift = (knob-128)*5;
      si5351bx_setfreq(OutBFO, User.BFO + shift);  
      if (isUSB == 1)
        si5351bx_setfreq(OutLO2, User.FIRST_IF + User.BFO + shift );
      else
        si5351bx_setfreq(OutLO2, User.FIRST_IF - User.BFO - shift );  
      sprintf(c, "%5d", shift);
      strcat(c, "Hz IF shift");
      printLine1(c);
      if (btnDown())  break;      //abort if this button is down
    }
    while(btnDown()){//attente tant que le bouton est pressé
      active_delay(50);
    }
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.IFshift = shift;
      lcd.setCursor(0, 1);
      lcd.print(F("IF shift stored "));
      EEPROM.put(4, User); // save all user parameters to EEPROM
      active_delay(2000);
    }
    RestoreExitMenu();
}



void CWSSBToggle(byte btn){
  if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("Mode CW/LSB/USB?"));
  }
  else {
      if (CwOn == 0 && isUSB == 1){ //mode CW
        isUSB = 0;
        CwOn = 1; // CW filter
        digitalWrite(CW_FILTER, 1);
        si5351bx_setfreq(OutLO2, User.FIRST_IF + User.CW_NARR_FILT );
        si5351bx_setfreq(OutBFO,User.CW_NARR_FILT + User.sideTone );
       }
      else if (CwOn == 1 && isUSB == 0){  // mode LSB
        CwOn = 0; //SSB filter
        digitalWrite(CW_FILTER, 0);
        si5351bx_setfreq(OutBFO, User.BFO + User.IFshift);  
        si5351bx_setfreq(OutLO2, User.FIRST_IF - User.BFO - User.IFshift );
      }
      else {
        // mode USB
        CwOn = 0;
        isUSB = 1;//SSB filter
        digitalWrite(CW_FILTER, 0);
        si5351bx_setfreq(OutBFO, User.BFO + User.IFshift); 
        si5351bx_setfreq(OutLO2, User.FIRST_IF + User.BFO + User.IFshift ); 
      }
   setFrequency(frequency);
   updateDisplay();
   resetBasefrequency();
   menuOn = 0;
  }
}



void ritToggle(byte btn){
  if (!btn){
    if (ritOn == 1){
      lcd.setCursor(0, 1);
      lcd.print(F("RIT:On          "));

    }
    else{

      lcd.setCursor(0, 1);
      lcd.print(F("RIT:Off         "));
    }
  }
  else {
    menuOn = 0;
      if (ritOn == 0){
        ritOn = 1;
        OrgRIT = analogRead(ANALOG_TUNING);
      }
      else {
        ritOn = 0;
        RIToffset=0;
      }
   resetBasefrequency();
   updateDisplay();
  }
}



void vfoToggle(byte btn){
  if (!btn){
    lcd.setCursor(0, 1);
    lcd.print(F("Select VFO A/B ?"));
  }
  else {
      if (vfoActive == VFO_B){
        vfoActive = VFO_A;
        User.vfoB = frequency;
        frequency = User.vfoA;
      }
      else {
        vfoActive = VFO_B;
        User.vfoA = frequency;
        frequency = User.vfoB;
      }
      setFrequency(frequency);
      updateDisplay();
      resetBasefrequency();
      menuOn = 0;
  }
}



void Tune(byte btn){
    int knob;
    unsigned long shift;
    if (!btn){ //selection du menu
      lcd.setCursor(0, 1);
      lcd.print(F("Tune SWR test ? "));
      return;
    }
    while(btnDown()){//attente tant que le bouton est pressé pour enter dans le mode
      active_delay(50);
    }
    TUNE = true;
    digitalWrite(CW_FILTER, 1); //le mode tune se fait comme en CW en déséquilibrant le BFO en passant dans le filtre CW
    updateDisplay();
    while(!btnDown()){
      if (digitalRead(PTT) == LOW && inTx == 0){ //passage en émission tune
        inTx = 1;
        digitalWrite(TX_RX, 1);
        digitalWrite(FBUTTON, LOW); // deactivate pullup
        active_delay(5); //wait to mute
        VFOfrequency = frequency;//vfo actif pour mode split
        si5351bx_setfreq(OutLO1, User.FIRST_IF + frequency);
        si5351bx_setfreq(OutLO2, User.FIRST_IF + User.CW_NARR_FILT); 
        si5351bx_setfreq(OutBFO,User.CW_NARR_FILT);
        tone(CW_TONE, User.sideTone); 
        digitalWrite(CW_CARRIER, 1);
        updateDisplay();
        active_delay(50); //debounce the PTT
      }
      while(digitalRead(PTT) == LOW && inTx == 1){// attente tant que appui sur PTT
        updateMeter(); //affichage du SWR
      }
      if (digitalRead(PTT) == HIGH && inTx == 1){ //relaché du ¨PTT
        noTone(CW_TONE);
        digitalWrite(CW_CARRIER, 0);
        active_delay(100); //debounce the PTT
        stopTx();
      }
      updateMeter();
    }
    while(btnDown()){//attente tant que le bouton est pressé à la sortie du mode
      active_delay(50);
    }
    TUNE = false;  
    //exit du mode au relaché du bouton restitution du mode CW/SSB
    RestoreExitMenu();
}




void SetCWtimeout(byte btn){
    byte CWtimeoutAdj;
    if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("CW hold delay ? "));
      return;
    }
    lcd.setCursor(0, 1);
    sprintf(c, "(%3d", cwDelayTime); //affiche la dernière valeur mémorisée
    strcat(c, "0) valid PTT");
    lcd.print(c);
    while (btnDown())  active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      CWtimeoutAdj = analogRead(ANALOG_TUNING) >> 2; // reduce resolution to 1/4
      if(CWtimeoutAdj<5){
        CWtimeoutAdj = 5;
      }
      sprintf(c, "%3d", CWtimeoutAdj);
      strcat(c, "0 ms delay   ");
      printLine1(c);
    }
    while (btnDown())
    active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.EEcwDelayTime = CWtimeoutAdj;
      cwDelayTime = CWtimeoutAdj;
      lcd.setCursor(0, 1);
      lcd.print(F("CW delay stored "));
      EEPROM.put(31, User.EEcwDelayTime);
      active_delay(2000);
    }
    resetBasefrequency();
    setFrequency(frequency);    
    updateDisplay();
    menuOn = 0;
}



void SetCWDotTime(byte btn){
    int cwSpeedAdj;
    if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("CW dot time ms ?"));
      return;
    }
      lcd.setCursor(0, 1);
      sprintf(c, "(%3d", cwSpeed); //affiche la dernière valeur mémorisée
      strcat(c, ")  valid PTT");
      lcd.print(c);
      while (btnDown())
      active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      cwSpeedAdj = analogRead(ANALOG_TUNING) >> 1; // reduce resolution to 1/2, 512 ms maxi
      if(cwSpeedAdj<20){
        cwSpeedAdj = 20;
      }
      sprintf(c, "%3d", cwSpeedAdj);
      strcat(c, "ms dot period");
      printLine1(c);
    }
    while (btnDown())
    active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.EEcwSpeed = cwSpeedAdj;
      cwSpeed = cwSpeedAdj;
      lcd.setCursor(0, 1);
      lcd.print(F("  CW dot stored "));
      EEPROM.put(32, User.EEcwSpeed);
      active_delay(2000);
    }
    resetBasefrequency();
    setFrequency(frequency);    
    updateDisplay();
    menuOn = 0;
}



void SetCWSideTone(byte btn){
int SideToneAdj;
    if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("CW sidetone adj?"));
      return;
    }
      lcd.setCursor(0, 1);
      sprintf(c, "(%3d", User.sideTone); //affiche la dernière valeur mémorisée
      strcat(c, ")  valid PTT");
      lcd.print(c);
      while (btnDown())
      active_delay(100);
    while(digitalRead(PTT) == HIGH && !btnDown()){//abort if this button or PTT is down
      SideToneAdj = analogRead(ANALOG_TUNING) >> 3; // reduce resolution to 1/8, 128x10 maxi
      if(SideToneAdj<60){
        SideToneAdj = 60;
      }
      if(SideToneAdj>80){
        SideToneAdj = 80;
      }
      sprintf(c, "%2d", SideToneAdj);
      strcat(c, "0 Hz sidetone ");
      printLine1(c);
    }
    while (btnDown())
    active_delay(100);
    //save the setting
    if (digitalRead(PTT) == LOW){
      User.sideTone = SideToneAdj*10;
      lcd.setCursor(0, 1);
      lcd.print(F("Sidetone stored "));
      EEPROM.put(29, User.sideTone);
      active_delay(2000);
    }
    resetBasefrequency();
    setFrequency(frequency);    
    updateDisplay();
    menuOn = 0;
}


void KeyerMode(byte btn){
  if (!btn){
    ToggleDone = false;
    if (Iambic_Key){
      lcd.setCursor(0, 1);
      lcd.print(F("Key Iambic mode "));
    }
    else{
      lcd.setCursor(0, 1);
      lcd.print(F("Key Straightmode"));
    }
  }
  else if (!ToggleDone){
      if (Iambic_Key){
        Iambic_Key = false;
        User.EEKeyerIambic = false;
        EEPROM.put(4, User); // save all user parameters to EEPROM
      }
      else {
        Iambic_Key = true;
        User.EEKeyerIambic = true;
        EEPROM.put(4, User); // save all user parameters to EEPROM
      }
      ToggleDone = true;
  }
}


void IambicMode(byte btn){
  if (!btn){
    ToggleDone = false;
    if (!IambicA){
      lcd.setCursor(0, 1);
      lcd.print(F("Key Iambic A    "));
    }
    else{
      lcd.setCursor(0, 1);
      lcd.print(F("Key Iambic B    "));
    }
  }
  else if (!ToggleDone){
      if (!IambicA){
        IambicA = 0x01;
        keyerControl = IambicA;
        User.EEIambicAB = IambicA;
        EEPROM.put(35, User.EEIambicAB);
      }
      else {
        IambicA = 0x00;
        keyerControl = IambicA;
        User.EEIambicAB = IambicA;
        EEPROM.put(35, User.EEIambicAB);
      }
      ToggleDone = true;
  }
}

void RestoreExitMenu(){
      if (CwOn == 1){
        digitalWrite(CW_FILTER, 1);
        si5351bx_setfreq(OutLO2, User.FIRST_IF + User.CW_NARR_FILT );
        si5351bx_setfreq(OutBFO,User.CW_NARR_FILT + User.sideTone );
      }
      else {  //SSB
        digitalWrite(CW_FILTER, 0);
        if (isUSB == 1)
          si5351bx_setfreq(OutLO2, User.FIRST_IF + User.BFO + User.IFshift );
        else       
        si5351bx_setfreq(OutLO2, User.FIRST_IF - User.BFO - User.IFshift );
      
        si5351bx_setfreq(OutBFO, User.BFO + User.IFshift);  
      }
    resetBasefrequency();
    setFrequency(frequency);    
    updateDisplay();
    menuOn = 0;
}
/*
void setBFO(byte btn){
    if (!btn){
      lcd.setCursor(0, 1);
      lcd.print(F("BFO Correction  "));
      return;
    }
    BFOadj();
    if (CwOn) si5351bx_setfreq(OutBFO,User.CW_NARR_FILT + User.sideTone ); 
    else si5351bx_setfreq(OutBFO, User.BFO + User.IFshift);
    resetBasefrequency();
    isUSB = 127; // to set LO1 with new BFO
    setFrequency(frequency);    
    updateDisplay();
    menuOn = 0;
}
*/
